if select(2, UnitClass("player")) ~= "PALADIN" and select(2, UnitClass("player")) ~= "WARRIOR"then
	return DisableAddOn("RaidDefenseStats")
end
local name, rds = ...
RDS = rds

local Frame1, Frame2 ,Frame3
local StrengthAdjust, ParryAdjust, DodgeAdjust, MasteryAdjust = 0, 0, 0, 0
local BuffStrengthAdjust, BuffParryAdjust, BuffDodgeAdjust, BuffMasteryAdjust, BuffMultiplierAdjust = 0, 0, 0, 0, 1

local function SkinIconButton(ButtonName) -- Added by Camealion
	if not ButtonName then return end
	local button = ButtonName
	if button then
		local texture = button:GetNormalTexture()
			if not texture then
			texture = _G[button:GetName().."Icon"]
	end

	if texture then
		button:SetTemplate("Default", true)
		texture:SetDrawLayer('OVERLAY') -- Make sure we can see the Icons.
		texture:ClearAllPoints()
		texture:Point("TOPLEFT", 2, -2)
		texture:Point("BOTTOMRIGHT", -2, 2)
		texture:SetTexCoord(0.08, 0.92, 0.08, 0.92)
        button:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square")
        button:SetPushedTexture(nil)
		end
	end
end

local function InjectRaidDefStats()
    local defenseCategory = PAPERDOLL_STATCATEGORIES["DEFENSE"]
    tinsert(defenseCategory.stats, "MASTERYADJUST")
    tinsert(defenseCategory.stats, "TOTALAVOIDANCE") 
    tinsert(defenseCategory.stats, "COMBATTABLE")
	local MY_RACES = {
        NightElf = 194,
        BloodElf = 195,
        Goblin = 196,
        Orc = 192,
        Tauren = 194,
        Troll = 190,
        Undead = 197,
        Draenei = 190,
        Dwarf = 194,
        Gnome = 193,
        Human = 189,
        Worgen = 192,
		}
	local race = MY_RACES[select(2, UnitRace("player"))]
	local missChance = 5
		if select(2, UnitRace("player")) == "NightElf" then
		missChance = 7
		end		
	if select(2, UnitClass("player")) == "PALADIN" then
		BPM = 2.25 else
		BPM = 1.5
	end
	
	

     PAPERDOLL_STATINFO["TOTALAVOIDANCE"] = {
    	updateFunc = function(statFrame, unit)
    		Frame1 = statFrame
    		if (unit ~= "player") then
				statFrame:Hide();
				return;
			end
	local dodge = GetDodgeChance()
	local DodgeAdjustChance = ( DodgeAdjust + BuffDodgeAdjust ) / 176.7189 
	local dodgeBeforeDR = 0.956 * ( 1 / (( 1 / ( dodge - 5 )) - 0.0152366 ))
	local dodgeAdjusted = dodgeBeforeDR + DodgeAdjustChance
	local dodgeAdjustedDR = ( 1 / ((  0.0152366 + ( 0.956 / dodgeAdjusted )))) + 5 -- total dodge % after DR
	local strength = select(1, UnitStat("player", 1))    
	local raceStrength = strength - race
	local parryFromStrength = (floor((ceil(( raceStrength + StrengthAdjust + BuffStrengthAdjust ) * BuffMultiplierAdjust ) - raceStrength ) * 0.27 )) /  176.7189	-- Parry % from Strength adjustments(Including Kings/MOTW and BS/HoW )
	local parryFromAdjust = ( ParryAdjust + BuffParryAdjust ) / 176.7189 --parry% from Parry Adjustments
	local parryBeforeDR = 0.956 * ( 1 / (( 1 / ( GetParryChance() - 5 )) - 0.0152366 ))
	local parryAdjusted = parryFromStrength + parryFromAdjust + parryBeforeDR -- total parry % Buffed before DR
	local parryAdjustedDR = ( 1 / ((  0.0152366 + ( 0.956 / parryAdjusted)))) + 5 	--total parry % (Buffed)after DR
	local chance = dodgeAdjustedDR + parryAdjustedDR
	PaperDollFrame_SetLabelAndText(statFrame, "Total Avoidance", chance, 1);
	statFrame.tooltip = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Avoidance").." "..string.format("%.02f", chance).."%"..FONT_COLOR_CODE_CLOSE;
	statFrame:Show();
    	end
    }
	PAPERDOLL_STATINFO["COMBATTABLE"] = {
	updateFunc = function(statFrame, unit)
	Frame2 = statFrame
    if (unit ~= "player") then
		statFrame:Hide();
		return;
	end
	local dodge = GetDodgeChance()
	local DodgeAdjustChance = ( DodgeAdjust + BuffDodgeAdjust ) / 176.7189 
	local dodgeBeforeDR = 0.956 * ( 1 / (( 1 / ( dodge - 5 )) - 0.0152366 ))
	local dodgeAdjusted = dodgeBeforeDR + DodgeAdjustChance
	local dodgeAdjustedDR = ( 1 / ((  0.0152366 + ( 0.956 / dodgeAdjusted )))) + 5 -- total dodge % after DR
	local strength = select(1, UnitStat("player", 1))    
	local raceStrength = strength - race
	local parryFromStrength = (floor((ceil(( raceStrength + StrengthAdjust + BuffStrengthAdjust ) * BuffMultiplierAdjust ) - raceStrength ) * 0.27 )) /  176.7189	-- Parry % from Strength adjustments(Including Kings/MOTW and BS/HoW )
	local parryFromAdjust = ( ParryAdjust + BuffParryAdjust ) / 176.7189 --parry% from Parry Adjustments
	local parryBeforeDR = 0.956 * ( 1 / (( 1 / ( GetParryChance() - 5 )) - 0.0152366 ))
	local parryAdjusted = parryFromStrength + parryFromAdjust + parryBeforeDR -- total parry % Buffed before DR
	local parryAdjustedDR = ( 1 / ((  0.0152366 + ( 0.956 / parryAdjusted)))) + 5 	--total parry % (Buffed)after DR
	-- mastery with food
	local masteryRating = (GetMastery() * 179.28004) + MasteryAdjust + BuffMasteryAdjust
	if select(2, UnitClass("player")) == "PALADIN" then
	blockAdjusted = (( masteryRating / 179.28 )* BPM ) + 5 else
	blockAdjusted = (( masteryRating / 179.28 )* BPM ) + 20
	end
	local totalChance = dodgeAdjustedDR + parryAdjustedDR + blockAdjusted + missChance
	local ratio = parryAdjustedDR/dodgeAdjustedDR
	PaperDollFrame_SetLabelAndText(statFrame, "C T Coverage", totalChance, 1, true)
	statFrame.tooltip = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Combat Table Coverage\n")..FONT_COLOR_CODE_CLOSE.."Automatically updates\nwhen you select buffs\nor input Stat change values\n\n\n".."Dodge:    "..HIGHLIGHT_FONT_COLOR_CODE..string.format("%.02f", dodgeAdjustedDR).."% \n"..FONT_COLOR_CODE_CLOSE.."Parry:      "..HIGHLIGHT_FONT_COLOR_CODE..string.format("%.02f", parryAdjustedDR).."% \n"..FONT_COLOR_CODE_CLOSE.."Block:     "..HIGHLIGHT_FONT_COLOR_CODE..string.format("%.02f", blockAdjusted).."% \n\n"..FONT_COLOR_CODE_CLOSE.."TOTAL:   "..HIGHLIGHT_FONT_COLOR_CODE..string.format("%.02f", totalChance).."% \n\n"..FONT_COLOR_CODE_CLOSE.."Dodge: Parry Ratio:"..HIGHLIGHT_FONT_COLOR_CODE..string.format("   1 : %.02f", ratio).." \n\n"..FONT_COLOR_CODE_CLOSE;
	statFrame:Show();
    	end
    }
    local class = select(2, UnitClass("player"))
    if class ~= "WARRIOR" and class ~= "PALADIN" then
    	PAPERDOLL_STATINFO["BLOCK"] = nil
    end
end


	PAPERDOLL_STATINFO["MASTERYADJUST"]= {
	updateFunc = function(statFrame, unit)
	Frame3 = statFrame
    if (unit ~= "player") then
		statFrame:Hide();
		return;
	end
	local masteryRating = (GetMastery() * 179.28004) + MasteryAdjust + BuffMasteryAdjust
	if select(2, UnitClass("player")) == "PALADIN" then
	blockAdjusted = (( masteryRating / 179.28004 )* BPM ) + 5 else
	blockAdjusted = (( masteryRating / 179.28004 )* BPM ) + 20
	end
	mastery = masteryRating / 179.28004
	
	PaperDollFrame_SetLabelAndText(statFrame, "Mastery", mastery, 1);
	statFrame.tooltip = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Mastery").." "..string.format("%.02f", mastery)..FONT_COLOR_CODE_CLOSE;
	statFrame:Show();
    	end
    }

local function onEvent(this, event, arg1)

	if event == "ADDON_LOADED" or event == "INSPECT_READY" then
		rds.Opts.Load()
		InjectRaidDefStats()
		rds.frame:SetScript("OnEvent", nil)
	end
	end



rds.Opts = CreateFrame("Frame", "R_D_S_Options", CharacterStatsPane, "BasicFrameTemplate") --Create the options Frame


local NewEditbox = function(name)
	local parent = rds.Opts
		
	if _G[parent:GetName() .. name .. 'Editbox'] then
		return _G[parent:GetName() .. name .. 'Editbox']
	end
	
	local editBox = CreateFrame('EditBox', parent:GetName() .. name .. 'Editbox', parent, 'InputBoxTemplate')
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			cSkinEditBox(editBox)-- Camealion
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	editBox:SetText(0)
	
	
	editBox:SetNumeric(true) --Makes the editbox only accept numbers.
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			editBox:SetSize(30, 16)	-- Camealion
		else	-- Camealion
			editBox:SetSize(45, 20)		
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	editBox:SetAutoFocus(false)
	editBox:SetScript('OnEscapePressed', function(self) self:ClearFocus() end)
	editBox.mod = 1
	editBox:SetScript('OnTextChanged', function(self)
		if editBox.AcquireText then
			editBox.AcquireText(self:GetNumber() * editBox.mod) 
		end
	end)

	editBox:SetScript('OnEditFocusLost', function(self)
		if self:GetNumber() == 0 then
			self:SetText(0)
		end
	end)

	editBox:SetScript('OnEnterPressed', function(self)
		self:ClearFocus()
	end)

	editBox.title = editBox:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	editBox.title:SetText(name)
	editBox.PosNeg = CreateFrame("Button", editBox:GetName().."PosNeg", editBox, "UIMenuButtonStretchTemplate")
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			cSkinButton(editBox.PosNeg)-- Camealion
			editBox.PosNeg:SetSize(16, 16)-- Camealion
			editBox.PosNeg:SetPoint("Right", editBox, "Left", -5, 0)-- Camealion
		else
			editBox.PosNeg:SetSize(20, 20)	
			editBox.PosNeg:SetPoint("Right", editBox, "Left", -2, -0)			
		end -- Camealion
	-- Skinning for ElvUI/Tukui End

	editBox.PosNeg:SetText("+")
	editBox.PosNeg:SetNormalFontObject("GameFontNormalLarge")
	editBox.PosNeg.tooltipText = "Click to set positive or negative."
	
	editBox.PosNeg:SetScript("OnClick", function(self)
		if editBox.mod > 0 then
			editBox.mod = -1
			self:SetText("-")
		else
			editBox.mod = 1
			self:SetText("+")
		end
		editBox.AcquireText(editBox:GetNumber() * editBox.mod)
	end)
	
	
	local prev = parent.prevEditBox
	if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then
	if prev then
		editBox:SetPoint("Top", prev,"Bottom", 0, -15)
		editBox.title:SetPoint("TopLeft", prev.title, "TopLeft", 0, -32)
	else
		editBox:SetPoint("TopLeft", 102, -56)
		editBox.title:SetPoint("TopLeft", parent, 20, -56)
	end	
	else
	if prev then
		editBox:SetPoint("Top", prev,"Bottom", 0, -13)
		editBox.title:SetPoint("TopLeft", prev.title, "TopLeft", 0, -32)
	else
		editBox:SetPoint("TopLeft", 102, -51)
		editBox.title:SetPoint("TopLeft", parent, 20, -56)
	end
	end
	
	editBox.title:SetJustifyH("LEFT")
	editBox.title:SetJustifyV("LEFT")

	parent.prevEditBox = editBox
	return editBox
end

------ 2nd set of editboxes
local NewEditbox2 = function(name)
	local parent = rds.Opts
		
	if _G[parent:GetName() .. name .. 'Editbox'] then
		return _G[parent:GetName() .. name .. 'Editbox']
	end
	
	local editBox2 = CreateFrame('EditBox', parent:GetName() .. name .. 'Editbox', parent, 'InputBoxTemplate')
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			cSkinEditBox(editBox2)-- Camealion
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	editBox2:SetText(0)
	
	
	editBox2:SetNumeric(true) --Makes the editbox only accept numbers.
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			editBox2:SetSize(30, 16)	-- Camealion
		else	-- Camealion
			editBox2:SetSize(45, 20)		
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	editBox2:SetAutoFocus(false)
	editBox2:SetScript('OnEscapePressed', function(self) self:ClearFocus() end)
	editBox2.mod = 1
	editBox2:SetScript('OnTextChanged', function(self)
		if editBox2.AcquireText then
			editBox2.AcquireText(self:GetNumber() * editBox2.mod) 
		end
	end)

	editBox2:SetScript('OnEditFocusLost', function(self)
		if self:GetNumber() == 0 then
			self:SetText(0)
		end
	end)

	editBox2:SetScript('OnEnterPressed', function(self)
		self:ClearFocus()
	end)

	editBox2.title = editBox2:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	editBox2.title:SetText(name)
	editBox2.PosNeg = CreateFrame("Button", editBox2:GetName().."PosNeg", editBox2, "UIMenuButtonStretchTemplate")
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			cSkinButton(editBox2.PosNeg)-- Camealion
			editBox2.PosNeg:SetSize(16, 16)-- Camealion
			editBox2.PosNeg:SetPoint("Right", editBox2, "Left", -5, 0)-- Camealion
		else
			editBox2.PosNeg:SetSize(20, 20)	
			editBox2.PosNeg:SetPoint("Right", editBox2, "Left", -2, -0)			
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	editBox2.PosNeg:SetText("+")
	editBox2.PosNeg:SetNormalFontObject("GameFontNormalLarge")
	editBox2.PosNeg.tooltipText = "Click to set positive or negative."
	
	editBox2.PosNeg:SetScript("OnClick", function(self)
		if editBox2.mod > 0 then
			editBox2.mod = -1
			self:SetText("-")
		else
			editBox2.mod = 1
			self:SetText("+")
		end
		editBox2.AcquireText(editBox2:GetNumber() * editBox2.mod)
	end)
	
	
	local prev1 = parent.prev1EditBox
	-- Skinning for ElvUI/Tukui Start
	if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion	
		if prev1 then
			editBox2:SetPoint("Bottom", prev1,"Bottom", 0, -49)
			editBox2.title:SetPoint("TopLeft", prev1.title, "TopLeft", 0, -49)
		else
			editBox2:SetPoint("TopLeft", 102, -199)
			editBox2.title:SetPoint("TopLeft", parent, 20, -202)
		end
	else
		if prev1 then
			editBox2:SetPoint("Bottom", prev1,"Bottom", 0, -49)
			editBox2.title:SetPoint("TopLeft", prev1.title, "TopLeft", 0, -49)
		else
			editBox2:SetPoint("TopLeft", 102, -199)
			editBox2.title:SetPoint("TopLeft", parent, 20, -202)
		end
	end -- Camealion
	-- Skinning for ElvUI/Tukui End
	
	editBox2.title:SetJustifyH("LEFT")
	editBox2.title:SetJustifyV("LEFT")

	parent.prev1EditBox = editBox2
	return editBox2
end
local prevDrop
local NewDropDownMenu = function(name, parent, title, items)
	if _G[name] then
		return _G[name]
	end

	local drop = CreateFrame("Button", name, rds.Opts, "UIDropDownMenuTemplate") 
	drop:ClearAllPoints() 
	drop:Show()
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			cSkinDropDownBox(drop)-- Camealion
		end -- Camealion
	-- Skinning for ElvUI/Tukui End
	drop.text = rds.Opts:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	drop.text:SetPoint("BottomLeft", drop,"TopLeft",0, 0)
	drop.text:SetText(title)

	
	local function OnClick(self) 
		UIDropDownMenu_SetSelectedID(drop, self:GetID())
		drop.OnClick(self.value)
	end

	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo() 
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo() 
			info.text = v 
			info.value = v 
			info.func = OnClick 
			UIDropDownMenu_AddButton(info, level) 
		end
	end

	UIDropDownMenu_Initialize(drop, initialize) 
	UIDropDownMenu_SetWidth(drop, 160)
	-- Skinning for ElvUI/Tukui Start
		if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then -- Camealion
			-- Do nothing
		else -- Camealion
			UIDropDownMenu_SetButtonWidth(drop, 160)  -- Camealion
		end -- Camealion
	UIDropDownMenu_SetSelectedID(drop, 1) 
	UIDropDownMenu_JustifyText(drop, "LEFT")
	
	local prev = prevDrop
	
	--if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then --Camealion
		--if prev then--Camealion
			--drop:SetPoint("Top", prev, "Bottom", 0 ,-20) --Camealion
		--else--Camealion
			--drop:SetPoint("LEFT", R_D_S_OptionsStrengthEditbox,"RIGHT", 20, 0) --Camealion
		--end--Camealion
	--else --Camealion
		if prev then
			drop:SetPoint("Top", prev,"Bottom", 0 ,-17) 
		else
			drop:SetPoint("TopLeft", rds.Opts,"TopLeft", 155, -47) 
		end
	--end --Camealion
	
	prevDrop = drop
	
	
	drop.StrengthValue = 0
	drop.ParryValue = 0
	drop.DodgeValue = 0
	drop.MasteryValue = 0
	drop.BuffValue = 1
	
	return drop
end

function rds.Opts.Load()
	rds.Opts:Hide()
	rds.Opts:SetPoint("TopRight", CharacterFrame, 440,0)
	rds.Opts:SetSize(435, 422)
	rds.Opts.title = rds.Opts:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	rds.Opts.title:SetPoint("TopLeft", 145 ,-5)
	rds.Opts.title:SetText(HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Raid Defense Stats")..FONT_COLOR_CODE_CLOSE)
	

	
	local f = CreateFrame("Button", rds.Opts:GetName().."Mini", CharacterStatsPane,"UIPanelButtonTemplate")
	f:SetSize(32, 32)
	f:SetPoint("TopRight", CharacterFrame, -150, -29)
	f:SetScript("OnEnter", function() f:ShowButtonTooltip() end)
	f:SetScript("OnLeave", function() f:HideButtonTooltip() end)
	f:SetScript("OnClick", function(self)
		PlaySound("igCharacterInfoTab")
		ToggleFrame(rds.Opts) end)
	
		
	
	function f:ShowButtonTooltip()
		GameTooltip:SetOwner(f, "ANCHOR_TOPRIGHT", 122,2 )
		GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Raid Defense Stats")..FONT_COLOR_CODE_CLOSE)
		GameTooltip:Show()
	end
	function f:HideButtonTooltip()
		GameTooltip:Hide()
		end

	SLASH_RDS1 = "/rds";
  	SlashCmdList["RDS"] = function(msg)
		rds_SlashCommandHandler(msg);
	end
	function rds_SlashCommandHandler(msg)
	PlaySound("igCharacterInfoTab")
	ToggleFrame(rds.Opts)
	
	end

	
	
	f:SetNormalTexture("Interface\\Icons\\INV_Shield_06")
	f:SetPushedTexture("Interface\\Icons\\INV_Shield_06")
	f:SetHighlightTexture("Interface\\Icons\\INV_Shield_06")

	f:GetNormalTexture():SetTexCoord(0, 1, 0, 1)
	f:GetPushedTexture():SetTexCoord(0, 1, 0, 1)
	f:GetHighlightTexture():SetTexCoord(0, 1, 0, 1)

	f:GetNormalTexture():SetBlendMode("DISABLE")
	f:GetPushedTexture():SetBlendMode("DISABLE")
	f:GetHighlightTexture():SetBlendMode("DISABLE")

	rds.Opts:UnregisterEvent("INSPECT_READY")
	
	NewEditbox("Strength").AcquireText = function(number)
		StrengthAdjust = number --These numbers are updated as you type.
		PAPERDOLL_STATINFO["TOTALAVOIDANCE"].updateFunc(Frame1, "player")
		PAPERDOLL_STATINFO["COMBATTABLE"].updateFunc(Frame2, "player")
		PAPERDOLL_STATINFO["MASTERYADJUST"].updateFunc(Frame3, "player")
	end

	NewEditbox("Dodge").AcquireText = function(number)
		DodgeAdjust = number
		PAPERDOLL_STATINFO["TOTALAVOIDANCE"].updateFunc(Frame1, "player")
		PAPERDOLL_STATINFO["COMBATTABLE"].updateFunc(Frame2, "player")
		PAPERDOLL_STATINFO["MASTERYADJUST"].updateFunc(Frame3, "player")
	end

	NewEditbox("Parry").AcquireText = function(number)
		ParryAdjust = number
		
		PAPERDOLL_STATINFO["TOTALAVOIDANCE"].updateFunc(Frame1, "player")
		PAPERDOLL_STATINFO["COMBATTABLE"].updateFunc(Frame2, "player")
		PAPERDOLL_STATINFO["MASTERYADJUST"].updateFunc(Frame3, "player")
	end

	NewEditbox("Mastery").AcquireText = function(number)
		MasteryAdjust = number
		PAPERDOLL_STATINFO["TOTALAVOIDANCE"].updateFunc(Frame1, "player")
		PAPERDOLL_STATINFO["COMBATTABLE"].updateFunc(Frame2, "player")
		PAPERDOLL_STATINFO["MASTERYADJUST"].updateFunc(Frame3, "player")
	end

	NewEditbox2("Gem 1").AcquireText = function(number)
		Gem1Adjust = number
		
		
	end

	NewEditbox2("Gem 2").AcquireText = function(number)
		Gem2Adjust = number

	end

	NewEditbox2("Gem 3").AcquireText = function(number)
		Gem3Adjust = number

	end

	NewEditbox2("Gem 4").AcquireText = function(number)
		Gem3Adjust = number
	end
	
	rds.Opts.text = rds.Opts:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	rds.Opts.text:SetPoint("TopLeft", 5 ,-375)
	rds.Opts.text:SetText(HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "If your current Buffs change, then you need to reselect the relevant Buff.\nIf you change the number of gems, then you need to reselect the gem")..FONT_COLOR_CODE_CLOSE)
	
	rds.Opts.text2 = rds.Opts:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	rds.Opts.text2:SetPoint("TopLeft", 120 ,-178)
	rds.Opts.text2:SetText(HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Select your Gem Changes")..FONT_COLOR_CODE_CLOSE)

	local food, strength, stat, gem1, gem2, gem3, gem4

	local function UpdateBuffStats()
		BuffStrengthAdjust = strength.StrengthValue + food.StrengthValue + gem1.StrengthValue + gem2.StrengthValue + gem3.StrengthValue + gem4.StrengthValue
		BuffParryAdjust =  food.ParryValue + gem1.ParryValue + gem2.ParryValue + gem3.ParryValue + gem4.ParryValue
		BuffDodgeAdjust =  food.DodgeValue + gem1.DodgeValue + gem2.DodgeValue + gem3.DodgeValue + gem4.DodgeValue
		BuffMasteryAdjust = food.MasteryValue + gem1.MasteryValue + gem2.MasteryValue + gem3.MasteryValue + gem4.MasteryValue
		BuffMultiplierAdjust = stat.BuffValue

	
		PAPERDOLL_STATINFO["TOTALAVOIDANCE"].updateFunc(Frame1, "player")
		PAPERDOLL_STATINFO["COMBATTABLE"].updateFunc(Frame2, "player")
		PAPERDOLL_STATINFO["MASTERYADJUST"].updateFunc(Frame3, "player")
	end

	
--Start of foodbuffs dropdown	
	food = NewDropDownMenu("FoodBuffs", rds.Opts, "   Select the Food you use in a Raid.", { 
	"None",
	"Beer-Basted Crocolisk",
	"Mushroom Sauce Mudfish",
	"Fortune Cookie",
	"Seafood Magnifique Feast",
	"Blackbelly Sushi",
	"Lavascale Minestrone",
	})
	food.OnClick = function(buff)
		if buff == "None" then
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 0
			food.MasteryValue = 0
			food.BuffValue = 0
		else
		if buff == "Beer-Basted Crocolisk" then
			food.StrengthValue = 90
			food.ParryValue = 0
			food.DodgeValue = 0
			food.MasteryValue = 0
			food.BuffValue = 0
		elseif buff == "Mushroom Sauce Mudfish" then 
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 90
			food.MasteryValue = 0
			food.BuffValue = 0
		elseif buff == "Fortune Cookie" then
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 90
			food.MasteryValue = 0
			food.BuffValue = 0
		elseif buff == "Seafood Magnifique Feast" then
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 90
			food.MasteryValue = 0
			food.BuffValue = 0
		elseif buff == "Blackbelly Sushi" then
			food.StrengthValue = 0
			food.ParryValue = 90
			food.DodgeValue = 0
			food.MasteryValue = 0
			food.BuffValue = 0
		elseif buff == "Lavascale Minestrone" then
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 0
			food.MasteryValue = 90
			food.BuffValue = 0
			end
						for i = 1, 40 do
			local spellId = select (11, UnitAura("player",i))
			if not spellId then break end 
			if (spellId == 87549 or spellId == 87554 or spellId == 87555 or spellId == 87545) then UIErrorsFrame:AddMessage("You already have a Food Buff. Food Choices will be ignored.",1,1,1,1)PlaySoundFile("sound\\doodad\\belltolltribal.wav") 
			food.StrengthValue = 0
			food.ParryValue = 0
			food.DodgeValue = 0
			food.MasteryValue = 0
			food.BuffValue = 0
			end
			end
			end
			
			
		UpdateBuffStats()
	end
--End of FoodBuffs dropdown

--Start of StrengthBuffs dropdown
	strength = NewDropDownMenu("StrengthBuffs", rds.Opts, "   Select Strength Buffs you receive.", { 
	"None",
	"Battle Shout",
	"Horn of Winter",
	})
	strength.OnClick = function(buff)
	
    if buff == "None" then
			strength.StrengthValue = 0
			strength.BuffValue = 0
		else
			strength.StrengthValue = 549
			strength.BuffValue = 0
			
			for i = 1, 40 do
			local spellId = select (11, UnitAura("player",i))
			if not spellId then break end 
			if (spellId == 57330 or spellId == 6673) then UIErrorsFrame:AddMessage("You already have a Strength Buff. Strength Buff Choices will be ignored.",1,1,1)PlaySoundFile("sound\\doodad\\belltolltribal.wav") 
			strength.StrengthValue = 0
			strength.BuffValue = 0 end
	end
	end
		
		

		UpdateBuffStats()
	end
--End of StrengthBuffs dropdown

-- --Start of StatBuffs dropdown
	stat = NewDropDownMenu("StatBuffs", rds.Opts, "       Select Stat Buffs you receive.", { 
	"None",
	"Kings",
	"Mark of the Wild",
	})
	
	stat.OnClick = function(buff)
	if buff == "None" then
		stat.BuffValue = 1
		else stat.BuffValue = 1.05
		end
	for i = 1, 40 do
    local spellId = select (11, UnitAura("player",i))
    if not spellId then break end 
		if (spellId == 79062 or spellId == 79060) then UIErrorsFrame:AddMessage("You already have a Stat Buff. Stat Buff Choices will be ignored.",1,1,1,1)PlaySoundFile("sound\\doodad\\belltolltribal.wav") 
		stat.BuffValue = 1 end
		end
		
		
	UpdateBuffStats()	
	end
	--End of StatBuffs dropdown 

--Start of Gem1 dropdown	
	gem1 = NewDropDownMenu("Gems", rds.Opts, "", { 
	"None",
	"Fine Lava Coral",
	"Fine Ember Topaz",
	"Fractured Lightstone",
	"Fractured Amberjewel",
	"Puissant Elven Peridot",
	"Puissant Dream Emerald",
	"Resolute Lava Coral",
	"Resolute Ember Topaz",
	"Regal Elven Peridot",
	"Regal Dream Emerald",
	"Defender's Shadow Spinel",
	"Defender's Demonseye",
	"Champion's Lava Coral",
	"Skillful Lava Coral",
	"Skillful Ember Topaz",
	"Stalwart Lava Coral",
	"Flashing Queen's Garnet",
	"Flashing Inferno Ruby",
	})
	gem1.OnClick = function(buff)
		if buff == "None" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		else
		if buff == "Fine Lava Coral" then
			gem1.StrengthValue = 0
			gem1.ParryValue = (25 * Gem1Adjust)
			gem1.DodgeValue = 0
			gem1.MasteryValue = (25 * Gem1Adjust)
			gem1.BuffValue = 0
		elseif buff == "Fine Ember Topaz" then 
			gem1.StrengthValue = 0
			gem1.ParryValue = 20 * Gem1Adjust
			gem1.DodgeValue = 0
			gem1.MasteryValue = 20* Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Fractured Lightstone" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 50 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Fractured Amberjewel" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 40 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Puissant Elven Peridot" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 25 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Puissant Dream Emerald" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 20 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == ("Resolute Lava Coral" or "Regal Elven Peridot" )then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 25 * Gem1Adjust
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == ("Resolute Ember Topaz" or "Regal Dream Emerald") then
			gem1.StrengthValue = 0
			gem1.ParryValue = 0
			gem1.DodgeValue = 20 * Gem1Adjust
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Defender's Shadow Spinel" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 25 * Gem1Adjust
			gem1.DodgeValue = 0
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Defender's Demonseye" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 20 * Gem1Adjust
			gem1.DodgeValue = 0
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Champion's Lava Coral" then
			gem1.StrengthValue = 25 * Gem1Adjust
			gem1.ParryValue = 0
			gem1.DodgeValue = 25 * Gem1Adjust
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Skillful Lava Coral" then
			gem1.StrengthValue = 25 * Gem1Adjust
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 25 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Skillful Ember Topaz" then
			gem1.StrengthValue = 20 * Gem1Adjust
			gem1.ParryValue = 0
			gem1.DodgeValue = 0
			gem1.MasteryValue = 20 * Gem1Adjust
			gem1.BuffValue = 0
		elseif buff == "Stalwart Lava Coral" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 25 * Gem1Adjust
			gem1.DodgeValue = 25 * Gem1Adjust
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Flashing Queen's Garnet" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 50 * Gem1Adjust
			gem1.DodgeValue = 0
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
		elseif buff == "Flashing Inferno Ruby" then
			gem1.StrengthValue = 0
			gem1.ParryValue = 40 * Gem1Adjust
			gem1.DodgeValue = 0
			gem1.MasteryValue = 0
			gem1.BuffValue = 0
			end

			end
			
			
		UpdateBuffStats()
	end
--End of Gems dropdown
--Start of Gem1 dropdown	
	gem2 = NewDropDownMenu("Gems2", rds.Opts, "", { 
	"None",
	"Fine Lava Coral",
	"Fine Ember Topaz",
	"Fractured Lightstone",
	"Fractured Amberjewel",
	"Puissant Elven Peridot",
	"Puissant Dream Emerald",
	"Resolute Lava Coral",
	"Resolute Ember Topaz",
	"Regal Elven Peridot",
	"Regal Dream Emerald",
	"Defender's Shadow Spinel",
	"Defender's Demonseye",
	"Champion's Lava Coral",
	"Skillful Lava Coral",
	"Skillful Ember Topaz",
	"Stalwart Lava Coral",
	"Flashing Queen's Garnet",
	"Flashing Inferno Ruby",
	})
	gem2.OnClick = function(buff)
		if buff == "None" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		else
		if buff == "Fine Lava Coral" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 25 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 25 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Fine Ember Topaz" then 
			gem2.StrengthValue = 0
			gem2.ParryValue = 20 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 20 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Fractured Lightstone" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 50 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Fractured Amberjewel" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 40 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Puissant Elven Peridot" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 25 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Puissant Dream Emerald" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 20 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == ("Resolute Lava Coral" or "Regal Elven Peridot" )then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 25 * Gem2Adjust
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == ("Resolute Ember Topaz" or "Regal Dream Emerald") then
			gem2.StrengthValue = 0
			gem2.ParryValue = 0
			gem2.DodgeValue = 20 * Gem2Adjust
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Defender's Shadow Spinel" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 25 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Defender's Demonseye" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 20 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Champion's Lava Coral" then
			gem2.StrengthValue = 25 * Gem2Adjust
			gem2.ParryValue = 0
			gem2.DodgeValue = 25 * Gem2Adjust
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Skillful Lava Coral" then
			gem2.StrengthValue = 25 * Gem2Adjust
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 25 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Skillful Ember Topaz" then
			gem2.StrengthValue = 20 * Gem2Adjust
			gem2.ParryValue = 0
			gem2.DodgeValue = 0
			gem2.MasteryValue = 20 * Gem2Adjust
			gem2.BuffValue = 0
		elseif buff == "Stalwart Lava Coral" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 25 * Gem2Adjust
			gem2.DodgeValue = 25 * Gem2Adjust
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Flashing Queen's Garnet" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 50 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
		elseif buff == "Flashing Inferno Ruby" then
			gem2.StrengthValue = 0
			gem2.ParryValue = 40 * Gem2Adjust
			gem2.DodgeValue = 0
			gem2.MasteryValue = 0
			gem2.BuffValue = 0
			end

			end
			
			
		UpdateBuffStats()
	end
--End of Gem2 dropdown
--Start of Gem3 dropdown	
	gem3 = NewDropDownMenu("Gems3", rds.Opts, "", { 
	"None",
	"Fine Lava Coral",
	"Fine Ember Topaz",
	"Fractured Lightstone",
	"Fractured Amberjewel",
	"Puissant Elven Peridot",
	"Puissant Dream Emerald",
	"Resolute Lava Coral",
	"Resolute Ember Topaz",
	"Regal Elven Peridot",
	"Regal Dream Emerald",
	"Defender's Shadow Spinel",
	"Defender's Demonseye",
	"Champion's Lava Coral",
	"Skillful Lava Coral",
	"Skillful Ember Topaz",
	"Stalwart Lava Coral",
	"Flashing Queen's Garnet",
	"Flashing Inferno Ruby",
	})
	gem3.OnClick = function(buff)
		if buff == "None" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		else
		if buff == "Fine Lava Coral" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 25 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 25 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Fine Ember Topaz" then 
			gem3.StrengthValue = 0
			gem3.ParryValue = 20 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 20 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Fractured Lightstone" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 50 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Fractured Amberjewel" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 40 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Puissant Elven Peridot" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 25 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Puissant Dream Emerald" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 20 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == ("Resolute Lava Coral" or "Regal Elven Peridot" )then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 25 * Gem3Adjust
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == ("Resolute Ember Topaz" or "Regal Dream Emerald") then
			gem3.StrengthValue = 0
			gem3.ParryValue = 0
			gem3.DodgeValue = 20 * Gem3Adjust
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Defender's Shadow Spinel" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 25 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Defender's Demonseye" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 20 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Champion's Lava Coral" then
			gem3.StrengthValue = 25 * Gem3Adjust
			gem3.ParryValue = 0
			gem3.DodgeValue = 25 * Gem3Adjust
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Skillful Lava Coral" then
			gem3.StrengthValue = 25 * Gem3Adjust
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 25 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Skillful Ember Topaz" then
			gem3.StrengthValue = 20 * Gem3Adjust
			gem3.ParryValue = 0
			gem3.DodgeValue = 0
			gem3.MasteryValue = 20 * Gem3Adjust
			gem3.BuffValue = 0
		elseif buff == "Stalwart Lava Coral" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 25 * Gem3Adjust
			gem3.DodgeValue = 25 * Gem3Adjust
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Flashing Queen's Garnet" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 50 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
		elseif buff == "Flashing Inferno Ruby" then
			gem3.StrengthValue = 0
			gem3.ParryValue = 40 * Gem3Adjust
			gem3.DodgeValue = 0
			gem3.MasteryValue = 0
			gem3.BuffValue = 0
			end

			end
			
			
		UpdateBuffStats()
	end
--End of Gem3 dropdown
--Start of Gem4 dropdown	
	gem4 = NewDropDownMenu("Gems4", rds.Opts, "", { 
	"None",
	"Fine Lava Coral",
	"Fine Ember Topaz",
	"Fractured Lightstone",
	"Fractured Amberjewel",
	"Puissant Elven Peridot",
	"Puissant Dream Emerald",
	"Resolute Lava Coral",
	"Resolute Ember Topaz",
	"Regal Elven Peridot",
	"Regal Dream Emerald",
	"Defender's Shadow Spinel",
	"Defender's Demonseye",
	"Champion's Lava Coral",
	"Skillful Lava Coral",
	"Skillful Ember Topaz",
	"Stalwart Lava Coral",
	"Flashing Queen's Garnet",
	"Flashing Inferno Ruby",
	})
	gem4.OnClick = function(buff)
		if buff == "None" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		else
		if buff == "Fine Lava Coral" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 25 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 25 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Fine Ember Topaz" then 
			gem4.StrengthValue = 0
			gem4.ParryValue = 20 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 20 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Fractured Lightstone" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 50 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Fractured Amberjewel" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 40 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Puissant Elven Peridot" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 25 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Puissant Dream Emerald" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 20 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == ("Resolute Lava Coral" or "Regal Elven Peridot" )then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 25 * Gem4Adjust
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == ("Resolute Ember Topaz" or "Regal Dream Emerald") then
			gem4.StrengthValue = 0
			gem4.ParryValue = 0
			gem4.DodgeValue = 20 * Gem4Adjust
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Defender's Shadow Spinel" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 25 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Defender's Demonseye" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 20 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Champion's Lava Coral" then
			gem4.StrengthValue = 25 * Gem4Adjust
			gem4.ParryValue = 0
			gem4.DodgeValue = 25 * Gem4Adjust
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Skillful Lava Coral" then
			gem4.StrengthValue = 25 * Gem4Adjust
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 25 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Skillful Ember Topaz" then
			gem4.StrengthValue = 20 * Gem4Adjust
			gem4.ParryValue = 0
			gem4.DodgeValue = 0
			gem4.MasteryValue = 20 * Gem4Adjust
			gem4.BuffValue = 0
		elseif buff == "Stalwart Lava Coral" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 25 * Gem4Adjust
			gem4.DodgeValue = 25 * Gem4Adjust
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Flashing Queen's Garnet" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 50 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
		elseif buff == "Flashing Inferno Ruby" then
			gem4.StrengthValue = 0
			gem4.ParryValue = 40 * Gem4Adjust
			gem4.DodgeValue = 0
			gem4.MasteryValue = 0
			gem4.BuffValue = 0
			end

			end
			
			
		UpdateBuffStats()
	end
--End of Gems dropdown

-- Skinning for ElvUI and Tukui by Camealion
	if IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui") then
		R_D_S_Options:StripTextures()
		R_D_S_Options:SetTemplate("Transparent")
		cSkinCloseButton(R_D_S_OptionsCloseButton)
		SkinIconButton(R_D_S_OptionsMini)
	end
end

rds.frame = CreateFrame("Frame")
rds.frame:RegisterEvent("ADDON_LOADED")

rds.frame:SetScript("OnEvent", onEvent)